using System.Collections;
using System.Collections.Generic;
using System.Runtime.CompilerServices;
using TMPro;
using UnityEngine;

[assembly: InternalsVisibleTo("TFramework.Editor")]

namespace TFramework
{
    [DefaultExecutionOrder(-10000)]
    [AddComponentMenu("TFramework/ȫֹ(Main)")]
    [DisallowMultipleComponent]
    public class Main : SingletonBehaviourBase<Main>
    {
        [SerializeField]
        internal List<BaseManager> m_ManagerList = new List<BaseManager>();

        //public bool IsEnableDebug;

        /// <summary>
        /// MonoűʹUpdate¼
        /// </summary>
        public TAction onUpdate;

        protected override void Awake()
        {
            base.Awake();
        }

        // Start is called before the first frame update
        void Start()
        {
            
        }

        // Update is called once per frame
        void Update()
        {
            onUpdate?.Invoke();
        }

        /// <summary>
        /// ȡָ͹
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <returns></returns>
        public static T GetMagr<T>()where T:MonoBehaviour
        {
            T magr = Instance?.m_ManagerList.Find(p => p.GetType() == typeof(T)) as T;
            if (magr == null)
                Log.Error($"{typeof(T).Name}δע");
            return magr;
        }

        /// <summary>
        /// ʱִ
        /// </summary>
        /// <param name="time">ʱʱ</param>
        /// <param name="action">ִ¼</param>
        public Coroutine Delay(float time, TAction action) => StartCoroutine(DelayAction(time, action));

        /// <summary>
        /// ʱִ
        /// </summary>
        /// <param name="time"></param>
        /// <param name="action"></param>
        /// <returns></returns>
        private IEnumerator DelayAction(float time, TAction action)
        {
            yield return new WaitForSeconds(time);
            action?.Invoke();
        }
    }

    public delegate void TAction();
    public delegate void TAction<in T>(T arg0);
    public delegate void TAction<in T1, in T2>(T1 arg0, T2 arg1);
    public delegate void TAction<in T1, in T2, in T3>(T1 arg0, T2 arg1, T3 arg2);
    public delegate TRes TFunc<out TRes>();
    public delegate TRes TFunc<in T1, out TRes>(T1 arg0);
    public delegate TRes TFunc<in T1, in T2, out TRes>(T1 arg0, T2 arg1);

    public enum ResLoadMode
    {
        Resourece,
        AssetBundle
    }

    public enum UpdateMode
    {
        Editor,
        Loacl,
        Bulid
    }
}
