using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace TFramework
{
    public class ObjectPoolMananger : BaseManager
    {
        public Transform m_poolTransform;

        private Dictionary<string, ObjectPool> _poolDic = new Dictionary<string, ObjectPool>();

        /// <summary>
        /// ע
        /// </summary>
        /// <param name="poolName"></param>
        /// <param name="objTemplate">ģ</param>
        /// <param name="maxCount"></param>
        /// <param name="takeOutEvent">ȡ¼</param>
        /// <param name="recycleEvent">¼</param>
        public void RegisterPool(string poolName, GameObject objTemplate, int maxCount, TAction<GameObject> takeOutEvent = null, TAction<GameObject> recycleEvent = null)
        {
            if (_poolDic.ContainsKey(poolName))
                Log.Error($"ء{poolName}עᣬظעᣡ");
            else
            {
                new GameObject(poolName).transform.parent = m_poolTransform;
                _poolDic.Add(poolName, new ObjectPool(objTemplate, maxCount, takeOutEvent, recycleEvent));
            }
        }

        /// <summary>
        /// ȡ
        /// </summary>
        /// <param name="poolName"></param>
        /// <returns></returns>
        public GameObject TakeOutObj(string poolName)
        {
            if (_poolDic.ContainsKey(poolName))
                return _poolDic[poolName].TakeOutObj();
            else
            {
                Log.Error($"Ϊ{poolName}Ķأ");
                return null;
            }
        }

        /// <summary>
        /// ն
        /// </summary>
        /// <param name="poolName"></param>
        /// <param name="obj"></param>
        public void RecycleObj(string poolName, GameObject obj)
        {
            if (_poolDic.ContainsKey(poolName))
            {
                obj.transform.SetParent(m_poolTransform.Find(poolName),false);
                _poolDic[poolName].RecycleObj(obj);
            }
            else
                Log.Error($"Ϊ{poolName}Ķأ");
        }

        /// <summary>
        /// ն
        /// </summary>
        /// <param name="poolName"></param>
        /// <param name="objs"></param>
        public void RecycleObjs(string poolName, IEnumerable<GameObject> objs)
        {
            foreach (var item in objs)
            {
                RecycleObj(poolName, item);
            }
        }

        /// <summary>
        /// Ƿڶ
        /// </summary>
        /// <param name="poolName"></param>
        /// <returns></returns>
        public bool IsHaveObjPool(string poolName) => _poolDic.ContainsKey(poolName);

        /// <summary>
        /// ָ
        /// </summary>
        public void ClearObjpool(string poolName)
        {
            if (IsHaveObjPool(poolName))
                _poolDic[poolName].Clear();
        }

        /// <summary>
        /// ж
        /// </summary>
        public void ClearAll()
        {
            foreach (var item in _poolDic)
                item.Value.Clear();
        }
    }
}
