using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace TFramework
{
    /// <summary>
    /// Monoģʽ
    /// </summary>
    /// <typeparam name="T"></typeparam>
    [DisallowMultipleComponent]
    [DefaultExecutionOrder(-10000)]
    public class SingletonBehaviourBase<T> : MonoBehaviour where T : MonoBehaviour
    {
        public bool doNotDestroy;

        private static T _instance;

        /// <summary>
        /// ǰʵ
        /// </summary>
        public static T Instance => _instance;


        protected virtual void Awake()
        {
            if (_instance == null)
                _instance = GetComponent<T>();
            else
                throw new UnityException($"ࡾ{typeof(T).FullName}ʵǲģ");
            if (doNotDestroy&&_instance!=null)
            {
                DontDestroyOnLoad(gameObject);
            }
        }

        protected virtual void OnDestroy() => _instance = null;
    }
}
