﻿/****************************************************
    文件：BindStrData.cs
    作者：陶长春
    邮箱：376248129@qq.com
    日期：2025年4月28日 7:43:27
    UnityVersion: 2021.3.13f1
    功能：string类型绑定
*****************************************************/
using UnityEngine.UI;

namespace TFramework
{
    public class BindStrData : BindDataBase<string>
    {
        protected override void BindEvent(UIBehaviour uI)
        {
            uI.GetComponent<Slider>()?.onValueChanged.AddListener((value) => Data = value.ToString());
            uI.GetComponent<Scrollbar>()?.onValueChanged.AddListener(value => Data = value.ToString());
            uI.GetComponent<InputField>()?.onValueChanged.AddListener(value => Data = value);
        }

        protected override void DataValueChangeEvent()
        {
            foreach (var item in m_UIs)
            {
                if (item.GetComponent<Text>())
                    item.GetComponent<Text>().text = Data.ToString();
                if (item.GetComponent<InputField>())
                    item.GetComponent<InputField>().text = Data;
            }
        }
    }
}