using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace TFramework
{
    /// <summary>
    /// UIԴ
    /// </summary>
    public class UIResourceAttribute : Attribute
    {
        public ResLoadMode LoadMode { get; private set; }
        public string ResourcePath { get; private set; }
        public string AssetBundleName { get; private set; }
        public string AssetPath { get; private set; }

        public string WorlUIDomain { get; private set; }

        /// <summary>
        /// UIԴ
        /// </summary>
        /// <param name="resourcePath">ԴResource·</param>
        /// <param name="assetBundleName">ԴAB</param>
        /// <param name="assetPath">Դ·</param>
        /// <param name="loadMode">ģʽ</param>
        /// <param name="canvasType">UICanvas</param>
        /// <param name="worldUIDomain">UI</param>
        public UIResourceAttribute(string resourcePath, string assetBundleName, string assetPath, ResLoadMode loadMode,string worldUIDomain)
        {
            LoadMode = loadMode;
            ResourcePath = resourcePath;
            AssetBundleName = assetBundleName;
            AssetPath = assetPath;
            WorlUIDomain = worldUIDomain;
        }

        public UIResourceAttribute(string resourcePath, string worldUIDomain)
        {
            LoadMode = ResLoadMode.Resourece;
            ResourcePath = resourcePath;
            AssetBundleName = "";
            AssetPath = "";
            WorlUIDomain = worldUIDomain;
        }

        public UIResourceAttribute(string assetBundleName, string assetPath, string worldUIDomain)
        {
            LoadMode = ResLoadMode.AssetBundle;
            ResourcePath = "";
            AssetBundleName = assetBundleName;
            AssetPath = assetPath;
            WorlUIDomain = worldUIDomain;
        }
    }
}
